local messages = {}
local function ReflowMessages()
    local offsetY = 5
    for i = #messages, 1, -1 do
        local msg = messages[i]
        msg:ClearAllPoints()
        msg:SetPoint(
                "BOTTOMLEFT",
                CzechQuestsAddon.translationSpeechFrame.content,
                "BOTTOMLEFT",
                10,
                offsetY
        )
        offsetY = offsetY + msg:GetHeight()
    end

    if #messages == 0 then
        CzechQuestsAddon.translationSpeechFrame:Hide()
    end

    CzechQuestsAddon.translationSpeechFrame.content:SetHeight(offsetY + 5)

    CzechQuestsAddon.translationSpeechFrame:UpdateScrollChildRect()                 -- Ujistí se, že velikost obsahu je aktuální
    local maxScroll = CzechQuestsAddon.translationSpeechFrame:GetVerticalScrollRange()
    CzechQuestsAddon.translationSpeechFrame:SetVerticalScroll(maxScroll)            -- Nastaví rolování na dolní okraj

end

local function RemoveMessage(frame)
    for i, fs in ipairs(messages) do
        if fs == frame then
            local fadeAnimationGroup = fs:CreateAnimationGroup()
            local fadeOut = fadeAnimationGroup:CreateAnimation("Alpha")
            fadeOut:SetFromAlpha(1)
            fadeOut:SetToAlpha(0)
            fadeOut:SetDuration(0.2)
            fadeOut:SetStartDelay(0)

            fadeAnimationGroup:SetScript("OnFinished", function()
                table.remove(messages, i)
                fs:Hide()
                ReflowMessages()
            end)

            fs:Show()
            fadeAnimationGroup:Play()

            break
        end
    end
end

local function AddMessage(sender, message)
    local formattedText = string.format("|cffffd200%s|r\n%s", sender, message)
    local frame = CzechQuestsAddon:CreateTranslationSpeechFrameMessage(formattedText)

    CzechQuestsAddon.translationSpeechFrame:Show()

    table.insert(messages, frame)
    ReflowMessages()

    C_Timer.After(20, function()
        RemoveMessage(frame)
    end)
end

function CzechQuestsAddon:ShowSpeechTranslation(sender, message)
    local text = CzechQuestsAddon:GetData("speech", message)
    if text ~= nil then
        AddMessage(sender, text)
    end
end